<?php
// $Id$
function ccfhidden_access_list() {
  $page = array();
  $access_list = _ccfhidden_access_list();
  $page['ccfhidden_access_list'] = array(
    '#markup' => theme('ccfhidden_access_list', array('access' => $access_list)),
//    '#attached' => array(
//      'css' => array(drupal_get_path('module', 'ccfhidden') . '/ccfhidden.admin.css' => array()),
//    ),
  );

  return $page;
}

function _ccfhidden_get_access_roles($roles) {
	$r = user_roles();
	$options = array();
	foreach($r as $key => $role) {
		if(isset($roles[$key]) && $roles[$key]!=0) {
		   $options[$key] = $role;
		}
	}
  $output = '';
  if(count($options)) {
  	$output = theme('item_list',array('items' =>$options));
  }
	return  $output;
}

function theme_ccfhidden_access_list($variables) {
  $access = $variables['access'];
  $header = array(t('Access name'), t('Access type'), t('Roles'), array('data' => t('Operations'), 'colspan' => 2));
  $rows = array();
  foreach ($access as $a) {
    $row = array();
    $row[] = l($a->ccfh_name, 'admin/config/content/ccfilter/ccfhidden/edit/' . $a->ccfh_name);
    $link_attributes = array(
      'attributes' => array(
        'class' => array('ccfhidden-access-list-link'),
      ),
    );
   $row[] = $a->ccfh_type;
   $row[] = _ccfhidden_get_access_roles($a->ccfh_roles);
   if ($a->ccfh_name == 'default') {
      $row[] = l(t('edit'), 'admin/config/content/ccfilter/ccfhidden/edit/' . $a->ccfh_name, $link_attributes);
      $row[] = '';
    }
    else {
      $row[] = l(t('edit'), 'admin/config/content/ccfilter/ccfhidden/edit/' . $a->ccfh_name, $link_attributes);
      $row[] = l(t('delete'), 'admin/config/content/ccfilter/ccfhidden/delete/' . $a->ccfh_name, $link_attributes);
    }
    $rows[] = $row;
  }
  return theme('table', array('header' => $header, 'rows' => $rows));
}


/**
 * Form builder; Form for adding a new ccfhidden access style.
 *
 * @ingroup forms
 */
function ccfhidden_access_list_add_form($form, &$form_state) {
  $form['ccfhidden_name'] = array(
    '#type' => 'textfield',
    '#size' => '64',
    '#title' => t('Access name'),
    '#default_value' => '',
    '#description' => t('The name is used access style of ccfhidden filter. Use only lowercase alphanumeric characters, underscores (_), and hyphens (-).'),
    '#element_validate' => array('ccfhidden_access_list_name_add_validate'),
    '#required' => TRUE,
  );
  $form['ccfhidden_method_access'] = array(
    '#type' => 'select',
    '#title' => t('Access method'),
    '#options' => drupal_map_assoc(array('Allow','Deny')),
    '#default_value' => 'Deny',
  );
  $form['ccfhidden_roles_access'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Rule to roles'),
    '#options' => user_roles(),
    '#default_value' => array(0),
    '#element_validate' => array('ccfhidden_access_list_roles_validate'),
  );
  $form['ccfhidden_title'] = array(
    '#type' => 'textfield',
    '#title' => t('Predefined title for hidden content.'),
    '#default_value' => '',
  );
  $form['ccfhidden_title_allow'] = array(
    '#type' => 'textfield',
    '#title' => t('Predefined title for allow content.'),
    '#default_value' => '',
  );
  $form['ccfhidden_extraclass'] = array(
    '#type' => 'textfield',
    '#title' => t('Predefined extraclass'),
    '#default_value' => '',
  );
  $form['ccfhidden_allow_notpublished_node'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show in hidden content of unpublished nodes.'),
    '#default_value' => FALSE,
  );

  $form['ccfhidden_add_nodetitle'] = array(
    '#type' => 'checkbox',
    '#title' => t('Merge node title to allow contetent title.'),
    '#default_value' => FALSE,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Create new access'),
  );
  return $form;
}
function ccfhidden_access_list_name_add_validate($element, $form_state) {
  // Check for duplicates.
  $access_list = _ccfhidden_access_list();
  if (isset($access_list[$element['#value']])) {
    form_set_error($element['#name'], t('The ccfhidde access style name %name is already in use.', array('%name' => $element['#value'])));
  }
  // Check for illegal characters in access names.
  if (preg_match('/[^0-9a-z_\-]/', $element['#value'])) {
    form_set_error($element['#name'], t('Please only use lowercase alphanumeric characters, underscores (_), and hyphens (-) for style names.'));
  }
}
function ccfhidden_access_list_roles_validate($element, $form_state) {
// Check for chekboxes roles
  if(!count($element['#value'])) {
     form_set_error($element['#name'], t('Please select at least one role.'));
  }
}
/**
 * Submit handler for adding a new access.
 */
function ccfhidden_access_list_add_form_submit($form, &$form_state) {
 $access = $form_state['values'];
 $fields = array(
 'ccfh_name' => $access['ccfhidden_name'],
 'ccfh_type' => $access['ccfhidden_method_access'],
 'ccfh_roles' => serialize($access['ccfhidden_roles_access']),
 'ccfh_title' => $access['ccfhidden_title'],
 'ccfh_title_allow' => $access['ccfhidden_title_allow'],
 'ccfh_extraclass' => $access['ccfhidden_extraclass'],
 'ccfh_snode' => $access['ccfhidden_allow_notpublished_node'],
 'ccfh_tnode' => $access['ccfhidden_add_nodetitle'],
 );
 db_insert('ccfhidden_config')->fields($fields)->execute();
 drupal_set_message(t('Ccfhidden access %name was created.', array('%name' => $access['ccfhidden_name'])));
 $form_state['redirect'] = 'admin/config/content/ccfilter/ccfhidden/';
}

/**
 * Form builder; Form for adding a new ccfhidden access style.
 *
 * @ingroup forms
 */
function ccfhidden_access_list_form($form, &$form_state, $access_name) {

  $title = t('Edit %name access profile', array('%name' => $access_name));
  drupal_set_title($title, PASS_THROUGH);
  $access_list = _ccfhidden_access_list();
  if(isset($access_list[$access_name])){
  $data = $access_list[$access_name];

  $form['ccfhidden_name'] = array(
    '#type' => 'textfield',
    '#size' => '64',
    '#title' => t('Access name profile'),
    '#default_value' => $data->ccfh_name,
    '#description' => t('The name is used access style of ccfhidden filter. Use only lowercase alphanumeric characters, underscores (_), and hyphens (-).'),
    '#element_validate' => array('ccfhidden_access_list_name_validate'),
    '#disabled' => ($data->ccfh_name == 'default')?'DISABLED':'',
    '#required' => TRUE,
  );
//  ccfh_name,ccfh_type,ccfh_roles,ccfh_title,ccfh_title_allow,ccfh_extraclass,ccfh_snode,ccfh_tnode
  $form['ccfhidden_method_access'] = array(
    '#type' => 'select',
    '#title' => t('Access method'),
    '#options' => drupal_map_assoc(array('Allow','Deny')),
    '#default_value' => $data->ccfh_type,
  );
  $form['ccfhidden_roles_access'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Rule to roles'),
    '#options' => user_roles(),
    '#default_value' => $data->ccfh_roles,
    '#element_validate' => array('ccfhidden_access_list_roles_validate'),
  );
  $form['ccfhidden_title'] = array(
    '#type' => 'textfield',
    '#title' => t('Predefined title for hidden content'),
    '#default_value' => $data->ccfh_title,
  );
  $form['ccfhidden_title_allow'] = array(
    '#type' => 'textfield',
    '#title' => t('Predefined title for allow content'),
    '#default_value' => $data->ccfh_title_allow,
  );
  $form['ccfhidden_extraclass'] = array(
    '#type' => 'textfield',
    '#title' => t('Predefined extraclass'),
    '#default_value' => $data->ccfh_extraclass,
  );
  $form['ccfhidden_allow_notpublished_node'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show in hidden content of unpublished nodes'),
    '#default_value' => $data->ccfh_snode,
  );

  $form['ccfhidden_add_nodetitle'] = array(
    '#type' => 'checkbox',
    '#title' => t('concatenate predefined content title and node title'),
    '#default_value' => $data->ccfh_tnode,
  );
  $form['ccfhidden_sid'] = array(
    '#type' => 'hidden',
    '#default_value' => $data->ccfh_sid,
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save access'),
  );
  }
  return $form;
}

function ccfhidden_access_list_name_validate($element, $form_state) {
	// Check for duplicates.
  $access_list = _ccfhidden_access_list();
  if (isset($access_list[$element['#value']]) && (!isset($access_list[$element['#value']]->ccfh_sid) || $access_list[$element['#value']]->ccfh_sid != $form_state['values']['ccfhidden_sid'])) {
  	    form_set_error($element['#name'], t('The ccfhidde access style name %name is already in use.', array('%name' => $element['#value'])));
  }
 // Check for illegal characters in access names.
  if (preg_match('/[^0-9a-z_\-]/', $element['#value'])) {
    form_set_error($element['#name'], t('Please only use lowercase alphanumeric characters, underscores (_), and hyphens (-) for style names.'));
  }
}

function ccfhidden_access_list_form_submit($form, &$form_state) {
 $access = $form_state['values'];
 $fields = array(
 'ccfh_name' => $access['ccfhidden_name'],
 'ccfh_type' => $access['ccfhidden_method_access'],
 'ccfh_roles' => serialize($access['ccfhidden_roles_access']),
 'ccfh_title' => $access['ccfhidden_title'],
 'ccfh_title_allow' => $access['ccfhidden_title_allow'],
 'ccfh_extraclass' => $access['ccfhidden_extraclass'],
 'ccfh_snode' => $access['ccfhidden_allow_notpublished_node'],
 'ccfh_tnode' => $access['ccfhidden_add_nodetitle'],
 );
 db_update('ccfhidden_config')
      ->fields($fields)
      ->condition('ccfh_sid', $access['ccfhidden_sid'])
      ->execute();
 drupal_set_message(t('Ccfhidden access %name was updated.', array('%name' => $access['ccfhidden_name'])));
 $form_state['redirect'] = 'admin/config/content/ccfilter/ccfhidden';
}


/**
 * Form builder; Form for deleting an cchfhidden access.
 *
 * @param $access
 * @ingroup forms
 */
function ccfhidden_access_list_delete_form($form, $form_state, $access) {
  $form_state['ccfhidden_name'] = $access;
  return confirm_form(
    $form,
    t('Do you really want to delete ccfhidden access  "%access"', array('%access' => $access)),
    'admin/config/content/ccfilter/ccfhidden',
    '',
    t('Delete'),  t('Cancel')
  );
}

function ccfhidden_access_list_delete_form_submit($form, &$form_state) {
  $access = $form_state['ccfhidden_name'];
  if ($access == 'default') {
  	drupal_set_message(t('You can not delete predefined access "%name".', array('%name' => $access)));
  }
  else {
   db_delete('ccfhidden_config')
      ->condition('ccfh_name', $access)
  	  ->execute();
  drupal_set_message(t('Ccfhidden access %name was deleted.', array('%name' => $access)));
  }
  $form_state['redirect'] = 'admin/config/content/ccfilter/ccfhidden';
}
