// $Id$
// author: olk olk2@mail.ru (aka - Helg@drupal.org)

(function ($) {
Drupal.behaviors.cchidden = {
   attach: function (context, settings) {
   $('.ccfhidden-wrapper').once('ccfhidden-wrapper', function () {
   	 var text = $(this);
     Drupal.ccfchiddenGetAccess(text);
   });
  }
};

Drupal.ccfchiddenGetAccess = function(text) {
    var action = 'http://' + window.location.hostname +'/ccfhidden/js_access';
    var access = $("input[name=ccfhidden-access]",text).val();
    var nid = $("input[name=ccfhidden-node-nid]",text).val();
    var fnid = $("input[name=ccfhidden-nid]",text).val();
    var fcid = $("input[name=ccfhidden-cid]",text).val();
    var fragment_id = $("input[name=ccfhidden-fragment-id]",text).val();
    var is_title_node = $("input[name=ccfhidden-is-title-node]",text).val();
    var is_unpublis_node = $("input[name=ccfhidden-is-unpublish-node]",text).val();

    if(!access) {
    	access = 'default';
    }
    $.ajax({
    type: "GET",
    url: action+'/'+access,
    dataType: "json",
    success: function(result) {
     var acc = result['data'];
     if(acc == 'allow') {
     	   var body = $('.ccfhidden-body',text);
     	   if(!fcid) {
     	   	 fcid = 0;
     	   }
   		   if (nid) { Drupal.ccfhiddenLoadNode(body,nid,access,is_title_node,is_unpublis_node); }
         else { Drupal.ccfhiddenLoadContent(body,fnid,fcid,fragment_id); }
         $('.ccfhidden-title-allow:parent',text).show();
     }
     else {
       $('.ccfhidden-title:parent',text).show();
     }
    }
  });
}

Drupal.ccfhiddenLoadNode = function(body,nid,access,is_title_node,is_unpublis_node) {
    var action = 'http://' + window.location.hostname +'/ccfhidden/js_load_node/'+nid+'/'+access;
    $(body).addClass('processed');
    $.ajax({
    type: "GET",
    url: action,
    dataType: "json",
    success: function(result) {
      if (result['status']) {
        var text=result['data']['text'];
        var title=result['data']['title'];
        var publish=result['data']['publish'];
        if(title && is_title_node==1) {
        $(body).parent().find('.ccfhidden-title-allow').append('&nbsp;<span class="ccfhidden-node-title">'+title+'</span>').show();
        }
        if(is_unpublis_node == 1 || publish==1) {
        $(body).replaceWith(text);
        }
        else {
        $(body).replaceWith(Drupal.t('This node is unpublished'));
        }

       	 Drupal.attachBehaviors($(body));
      }
      else {
        $(body).replaceWith(Drupal.t('Error loading node'));
      }

    },
    complete: function(result) {
     $(body).removeClass('processed');
     $(body).addClass('loaded');
    },
    error: function(result) {
         $(body).replaceWith(Drupal.t('Error loading node'));

    }
  });
}

Drupal.ccfhiddenLoadContent = function(body,fnid,fcid,fragment_id) {
    var action = 'http://' + window.location.hostname +'/ccfhidden/js_load_ccfhidden/'+fnid+'/'+fcid+'/'+fragment_id
    $.ajax({
    type: "GET",
    url: action,
    dataType: "json",
    success: function(result) {
      if (result['status']) {
        var text=result['data'];
        $(body).replaceWith(text);
      	Drupal.attachBehaviors($(body));
      }
      else {
      	$(body).replaceWith(Drupal.t('Error loading hidden content'));
      }

    },
    error: function(result) {
         $(body).replaceWith(Drupal.t('Error loading hidden content'));

    }
  });
}

})(jQuery);
